/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2004 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Sam Lantinga
    slouken@libsdl.org
*/

#ifndef _SDL_direct3dext_h
#define _SDL_direct3dext_h

#include "SDL_video.h"

#include "begin_code.h"
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif


typedef enum {
	SDLD3DSCREENFLAG_VSYNC	= (1 << 0)
} SDLD3D_ScreenFlags;

typedef enum {
	SDLD3DBLEND_NORMAL		= 0,
	SDLD3DBLEND_MIXEDALPHA	= 1
} SDLD3D_BlendMode;

/* NOTE: Screen flags MUST be set before a screen is created.  Changing them
   after a Direct3D screen has been created will not affect the current screen.
   If the screen is recreated, however, the new flags will be used. */
extern DECLSPEC SDLD3D_ScreenFlags SDLCALL SDLD3D_GetScreenFlags();
extern DECLSPEC void SDLCALL SDLD3D_SetScreenFlags(SDLD3D_ScreenFlags flags);

extern DECLSPEC int SDLCALL SDLD3D_GetBlendMode(SDL_Surface *surface, SDLD3D_BlendMode *output_blend_mode);
extern DECLSPEC int SDLCALL SDLD3D_SetBlendMode(SDL_Surface *surface, SDLD3D_BlendMode blend_mode);

//extern DECLSPEC void SDLCALL SDLD3D_GetDirect3DDevice(void **output_device_pointer);

extern DECLSPEC int SDLCALL SDLD3D_GetSurfaceMemoryUsage(SDL_Surface *surface);


/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include "close_code.h"

#endif /* _SDL_direct3dext_h */
