/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997, 1998, 1999  Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Sam Lantinga
    slouken@libsdl.org
*/

#include "SDL_direct3dcommon.h"

//#pragma comment(lib, "dxerr9.lib")


/* Necessary libraries */
/* FIXME, davidl: Including the dxerr9 library in C code is only supported under the Visual C++ compiler. */
#ifdef _MSC_VER

// Link required libraries
//#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"dxerr9.lib")

#ifdef _DEBUG
#pragma comment(lib,"d3dx9d.lib")
#else
#pragma comment(lib,"d3dx9.lib")
#endif

#endif


static const char * CustomGetErrorString(HRESULT result)
{
	return "unknown custom error";
}

static const char * GetWinErrorString(HRESULT result)
{
	static char buf[512];

	if (!FormatMessage( 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) buf,
		512,
		NULL ))
	{
		// Handle the error.
		return "Could not retrieve error info.";
	}

	return buf;
}

const char * ConvertHresultToString(HRESULT result)
{
	switch ( HRESULT_FACILITY(result) )
	{
	case _FACD3D: /* _FACD3D is/should-be defined in the DX9 SDK's d3d9.h file */
#if _FACD3D != _FACDD
	case _FACDD: /* _FACDD is/should-be defined in the DX SDK */
#endif
		return DXGetErrorString9(result);

	case FACILITY_ITF: /* FACILITY_ITF usually indicates a custom/non-Microsoft HRESULT */
		return CustomGetErrorString(result);

	default:
		return GetWinErrorString(result);
	}
}
